﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;

using io = System.IO;

namespace Choinka
{
    /// <summary>
    /// Logika interakcji dla klasy MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            string ścieżkaPlikuAudio = io.Path.GetFullPath("choinka.mp3");
            if(File.Exists(ścieżkaPlikuAudio))
            {
                odtwarzaczAudio = new MediaPlayer();
                odtwarzaczAudio.Open(new Uri(ścieżkaPlikuAudio, UriKind.RelativeOrAbsolute));
                odtwarzaczAudio.MediaEnded += 
                    (a, e) => 
                    {
                        //odtwarzaczAudio = null;
                        odtwarzaczAudio.Position = new TimeSpan(0);
                        odtwarzaczAudio.Play();
                    };
                odtwarzaczAudio.Play();
            }
        }

        private MediaPlayer odtwarzaczAudio;

        #region Przenoszenie okna
        private bool czyPrzenoszenie = false;
        private Point punktPoczątkowy;
        private Cursor kursor;

        private void Window_MouseDown(object sender, MouseButtonEventArgs e)
        {
            if(e.ButtonState == Mouse.LeftButton)
            {
                czyPrzenoszenie = true;
                punktPoczątkowy = e.GetPosition(this);
                kursor = Cursor;
                Cursor = Cursors.Hand;
            }
        }

        private void Window_MouseMove(object sender, MouseEventArgs e)
        {
            if(czyPrzenoszenie)
            {
                Vector przesunięcie = e.GetPosition(this) - punktPoczątkowy;
                Left += przesunięcie.X;
                Top += przesunięcie.Y;
            }
        }

        private void Window_MouseUp(object sender, MouseButtonEventArgs e)
        {
            if(czyPrzenoszenie)
            {
                Cursor = kursor;
                czyPrzenoszenie = false;
            }
        }
        #endregion

        private void Window_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Escape) Close();
        }

        private bool czyUruchomianaAnimacjaZnikaniaOkna = false;

        private void okno_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (!czyUruchomianaAnimacjaZnikaniaOkna)
            {                
                Storyboard scenorysZnikaniaOkna = this.Resources["scenorysOkna"] as Storyboard;
                scenorysZnikaniaOkna.Begin();
                e.Cancel = true;
            }
        }

        private void Storyboard_Completed(object sender, EventArgs e)
        {
            czyUruchomianaAnimacjaZnikaniaOkna = true;
            Close();
        }
    }
}
